/*!
  AT90S2313-10PCѥץӡΥץ
  <pre>
        L0    L1
	   L2
        L3    L4

  SW0   SW1   SW2   SW3

  AT90S2313Υ־
  Program-Area $0000 - $03FF Flash    (1K x 16)
  Data-Area    $0000 - $001F reg  (32 x 8)
               $0020 - $005F I/O-reg  (64 x 8)
               $0060 - $00DF ¢SRAM (128 x 8)
  EEPROM-Area  $0000 - $007F EEPROM   (128 x 8)

  CPUΥԥۤϰʲ̤
  1  /RESET	i	/res, ISP-1
  2  PD0(RXD)	i	RXD
  3  PD1(TXD)	o	TXD
  4  XTAL2	-	XTAL2(10MHz)
  5  XTAL1	-	XTAL1
  6  PD2(INT1)	i	sw0()
  7  PD3(INT2)	i	sw1()
  8  PD4(T0)	i	sw2()
  9  PD5(T1)	i	sw3()
  10 GND	-	GND, ISP-5,6
  11 PD6(ICP)	o	Buzzer()
  12 PB0(AIN0)	o	led0()
  13 PB1(AIN1)	o	led1()
  14 PB2	o	led2()
  15 PB3(OCI)	o	led3()
  16 PB4	o	led4()
  17 PB5(MOSI)	i	nu, ISP-4
  18 PB6(MISO)	o	nu, ISP-3
  19 PB7(SCK)	o	nu, ISP-2
  20 VCC(46V)	-	+5V
  nu = not use
  </pre>
*/


/*!
  \file putibee.c
  \brief ץӡ
*/


#include <io.h>
#include <interrupt.h>
#include <sig-avr.h>
#include <progmem.h>


typedef unsigned char	BYTE;
typedef unsigned short	WORD;
typedef unsigned long	DWORD;


#define TRUE  1
#define FALSE 0

//#define BUZ_SILENT			//! BEEPOFFǽͭˤ

#define PRESET_SLEEP_TIM ( 30 )		//! KEY̵SLEEPλֻ

#define PRESET_1MS ( 256 - 10 )		//! ޤκ(1ms)

#define MASK_PORTB ( 0xa0 )		//<! PortBϻMASK
#define MASK_PORTD ( 0xbd )		//<! PortDϻMASK

#define SW_BUF_MAX ( 3 )		//<! åȽѤΥХåեʿ
#define SW_KEYBUF_MAX ( 3 )		//<! å٥ȥ塼ʿ
#define SW_KEYSCAN_TIM ( 10 )		//<! (ms)
#define SW_ON  0x10
#define SW_OFF 0x20
#define SW_CODE0 0x00
#define SW_CODE1 0x01
#define SW_CODE2 0x02
#define SW_CODE3 0x03
#define KEY_CODE0_ON  ( SW_ON  | SW_CODE0 )
#define KEY_CODE1_ON  ( SW_ON  | SW_CODE1 )
#define KEY_CODE2_ON  ( SW_ON  | SW_CODE2 )
#define KEY_CODE3_ON  ( SW_ON  | SW_CODE3 )
#define KEY_CODE0_OFF ( SW_OFF | SW_CODE0 )
#define KEY_CODE1_OFF ( SW_OFF | SW_CODE1 )
#define KEY_CODE2_OFF ( SW_OFF | SW_CODE2 )
#define KEY_CODE3_OFF ( SW_OFF | SW_CODE3 )

BYTE g_bySw_buf[ SW_BUF_MAX ];		//<! åȽѤΥХåե
BYTE g_bySw_keybuf[ SW_KEYBUF_MAX ];	//<! å٥ȥ塼ΥХåե
BYTE g_bySw_keybuf_wrpnt;		//<! å٥ȥ塼WritePnt
BYTE g_bySw_keybuf_rdpnt;		//<! å٥ȥ塼ReadPnt
BYTE g_bySw_keybuf_cnt;			//<! å٥ȥ塼

/* K_mon_System */
#define	K_MON_A_SIZE   ( 2 )	   	//! 2byte = 0-ffffh
#define	K_MON_VERSION  ( '2' ) 		//! System_version
#define	K_MON_CODE_ACK ( 'A' )
#define	K_MON_CODE_NAK ( 'N' )
#define	K_MON_CODE_ADD ( 'a' )
#define	K_MON_CODE_BUS ( 'b' )
#define	K_MON_CODE_MWR ( 'w' )
#define	K_MON_CODE_MRD ( 'r' )
#define	K_MON_CODE_PRD ( 'R' )
#define	K_MON_CODE_IWR ( 'o' )
#define	K_MON_CODE_IRD ( 'i' )
#define	K_MON_CODE_VER ( 'v' )
#define	K_MON_CODE_CAL ( 'c' )
#define	K_MON_CODE_GO  ( 'g' )
#define pokeb(a,b) ( *(volatile unsigned char *)(a) = (b) )
#define peekb(a) ( *(volatile unsigned char *)(a) )
#define k_mon_getc() inp( UDR )
#define k_mon_putc(a) outp( (a), UDR )


WORD g_wTime1sec_cnt;			//! 1ä५
#define DEF_WTIME1SEC_CNT 1000

WORD g_wTime1s_dec_cnt;			//! Ԥå
#define DEF_WTIME1S_DEC_CNT 0

WORD g_wTime1ms_dec_cnt;		//! Ԥms
#define DEF_WTIME1MS_DEC_CNT 0

WORD g_wTimeKey_cnt;			//! KEYTASKѥ

/* K_mon_System */
WORD g_wMoniter_reg_a;			//! ɥ쥹
BYTE g_byMoniter_reg_mode;		//! ⡼ɵ
BYTE g_byMoniter_reg_cnt;		//! ɥ쥹Υ


PROGMEM char g_cVersion_code[] = {
//---0123456789abcdef0123456789abcdef---
    "putibee        "			// Program Name (No edit)
    "\0"
    "1.12   "				// Firmware-Version
    "\0"
    "kawasan"				// Maker
    "\0"
//  "Wed Nov  5 23:46:48 2003"		// First date
    "Thu Nov 27 21:04:04 2003"		// Last Update
    "\0"
};					//! ץ

/*!
  LED

  

  ͤΤޤLEDȿǤޤ<br>
  bit0 LED0 = 0/1 = off/on<br>
  bit1 LED1 = 0/1 = off/on<br>
  bit2 LED2 = 0/1 = off/on<br>
  bit3 LED3 = 0/1 = off/on<br>
  bit4 LED4 = 0/1 = off/on
*/
void drv_led( BYTE code )
{
    outp( ( inp( PINB ) & 0xe0 ) | ( ~code & 0x1f ), PORTB );
}


/*!
  ֥

  

  \param byCode 0/!0 = off/on
*/
void drv_buz( BYTE byCode )
{
#ifndef BUZ_SILENT
    if ( byCode ) {
	// on
	outp( ( MASK_PORTD | 0x40 ), PORTD );
    } else {
	// off
	outp( ( MASK_PORTD & ~0x40 ), PORTD );
    }
#endif
}


/*!
  KEY塼ν

  \param byType ꥳ<br>
  0 = Reset All<br>
  1 = clear(ХåեݥȤReset)
*/
void init_swq( BYTE byType )
{
    g_bySw_keybuf_cnt = 0;

    if ( byType == 0 ) {
	g_bySw_keybuf_wrpnt = 0;
    }

    g_bySw_keybuf_rdpnt = g_bySw_keybuf_wrpnt;
}


/*!
  KEY塼γǼ

  塼äѤξ̵ư

  \param byCode 
*/
void psnd_swq( BYTE byCode )
{
    /* äѤȽ */
    if ( g_bySw_keybuf_cnt >= SW_KEYBUF_MAX ) {
	return;
    }

    /* 塼Ǽ */
    g_bySw_keybuf[ g_bySw_keybuf_wrpnt ++ ] = byCode;
    if ( g_bySw_keybuf_wrpnt >= SW_KEYBUF_MAX ) {
	g_bySw_keybuf_wrpnt = 0;
    }
    g_bySw_keybuf_cnt ++;
}


/*!
  KEY塼μ

  \param byCode ɤΥݥ
  \return 0/!0 = ̵/
*/
int prcv_swq( BYTE *byCode )
{
    /* äݤȽ */
    if ( g_bySw_keybuf_cnt == 0 ) {
	return 0;
    }

    /* 塼 */
    *byCode = g_bySw_keybuf[ g_bySw_keybuf_rdpnt ++ ];
    if ( g_bySw_keybuf_rdpnt >= SW_KEYBUF_MAX ) {
	g_bySw_keybuf_rdpnt = 0;
    }
    g_bySw_keybuf_cnt --;

    return 1;
}


/*!
  KEY
  
  \return BITξ<br>
  bit0 SW0 = 0/1 = off/on<br>
  bit1 SW1 = 0/1 = off/on<br>
  bit2 SW2 = 0/1 = off/on<br>
  bit3 SW3 = 0/1 = off/on
*/
BYTE drv_key( void )
{
    return ( ( ~inp( PIND ) ) >> 2 ) & 0x0f;
}


/*!
  SWϥɥ饤Фν

  \return 0ʤ
*/
void sw_init( void )
{
    int cnt;
    BYTE byDat;


    /* Хåեν */
    byDat = drv_key();
    for ( cnt = 0; cnt < SW_BUF_MAX; cnt ++ ) {
	g_bySw_buf[ cnt ] = byDat;
    }

    /* 塼ν */
    init_swq( 0 );
}


/*!
  ͤBYTEĹflag_bitѴ

  ex.<br>
  1 => 0000_0010

  \param iCode <br>ͤ07Ǥ¾϶ػߡ
  \return BYTEĹflag_bit
*/
BYTE i2bcode( int iCode )
{
    static BYTE byI2b[ 8 ] = {
	0x01, 0x02, 0x04, 0x08,
	0x10, 0x20, 0x40, 0x80,
    };


    return byI2b[ iCode ];
}


/*!
  KEYϽ

  㥿Ƚ򤷤ƥܥ򥭥塼
*/
void key_task( void )
{
    BYTE byCmp_on;
    BYTE byCmp_off;
    BYTE byCode;
    int cnt;


    //! rotation SW buffer
    for ( cnt = ( SW_BUF_MAX - 2 ); cnt >= 0 ; cnt -- ) {
	g_bySw_buf[ cnt + 1 ] = g_bySw_buf[ cnt ];
    }
    g_bySw_buf[ 0 ] = drv_key();


    // event-flag
    byCmp_on = g_bySw_buf[ 0 ];
    byCmp_off = ~g_bySw_buf[ 0 ];
    for ( cnt = 1; cnt < ( SW_BUF_MAX - 1 ); cnt ++ ) {
	byCmp_on &= g_bySw_buf[ cnt ];
	byCmp_off &= ~g_bySw_buf[ cnt ];
    }
    byCmp_on &= ~g_bySw_buf[ cnt ];
    byCmp_off &= g_bySw_buf[ cnt ];


    //! change event _|~ Ƚ (줿)
    if ( byCmp_on ) {
	//! н
	for ( cnt = 0; cnt < 4; cnt ++ ) {
	    byCode = i2bcode( cnt );
	    if ( byCmp_on & byCode ) {
		psnd_swq( (BYTE)( SW_ON | cnt ) );
	    }
	}
    }


    //! change event ~|_ Ƚ (Υ줿)
    if ( byCmp_off ) {
	//! н
	for ( cnt = 0; cnt < 4; cnt ++ ) {
	    byCode = i2bcode( cnt );
	    if ( byCmp_off & byCode ) {
		psnd_swq( (BYTE)( SW_OFF | cnt ) );
	    }
	}
    }
}


/*!
  KEY

  㥿Ƚ򤷤ƥܥ򥭥塼
  <table border>
  <tr><td></td><td>ξ</td><tr>
  <tr><td>0x00</td><td>̵</td><tr>
  <tr><td>KEY_CODE0_ON</td><td>SW0줿</td><tr>
  <tr><td>KEY_CODE0_OFF</td><td>SW0Υ줿</td><tr>
  <tr><td>KEY_CODE1_OFF</td><td>SW1Υ줿</td><tr>
  <tr><td>KEY_CODE2_OFF</td><td>SW2Υ줿</td><tr>
  <tr><td>KEY_CODE3_OFF</td><td>SW3Υ줿</td><tr>
  </table>

  \return 0/!0 = ̵/
*/
BYTE key_get( void )
{
    BYTE ret;


    if ( prcv_swq( &ret ) == 0 ) {
	ret = 0;
    }

    return ret;
}


/*!
  Init Timer0

  Timer08bitޤOverFlowǤγߤѤ롣
  CK=10MHzʤΤ1024ʬCNT0=101ms
  ư롣
*/
void tmr0_init( void )
{
    /* preset CNT0 */
    outp( PRESET_1MS, TCNT0 );

    /* set prescaler CK/1024 */
    outp( 5, TCCR0 );

    /* enable TMR0 interrupt */
    outp( inp( TIMSK ) | BV( TOIE0 ), TIMSK );

    /* Init 1secưflag */
    g_wTime1sec_cnt = DEF_WTIME1SEC_CNT;
}


/*!
  interrupt function (timer0 OverFlow)

  1ms˳ߵư
*/
SIGNAL( SIG_OVERFLOW0 )
{
    /* preset CNT0 */
    outp( PRESET_1MS, TCNT0 );

    /* 1msν */
    if ( g_wTime1ms_dec_cnt ) {
	g_wTime1ms_dec_cnt --;
    }

    /* 1ν */
    g_wTime1sec_cnt --;
    if ( g_wTime1sec_cnt == 0 ) {
	g_wTime1sec_cnt = DEF_WTIME1SEC_CNT;

	if ( g_wTime1s_dec_cnt ) {
	    g_wTime1s_dec_cnt --;
	}
    }

    /* Key-SWν */
    g_wTimeKey_cnt --;
    if ( g_wTimeKey_cnt == 0 ) {
	g_wTimeKey_cnt = SW_KEYSCAN_TIM;

	key_task();
    }
}


/*!
  Init UART

  9600bps 8bit-Data 1stop-bit Non-parity
  CK=10MHzʤΤUBRR=64(0.2%)
  ߤѤ
*/
void uart_init( void )
{
    /* enable RxInt, RxD, TxD */
    outp( BV( RXCIE ) | BV( RXEN ) | BV( TXEN ), UCR );

    /*9600bps at 10MHz*/
    outp( 64, UBRR );
}


/*!
  interrupt function (UART )

  K_mon_System
*/
SIGNAL( SIG_UART_RECV )
{
    BYTE rev_dat;
    BYTE tx_dat;


    rev_dat = k_mon_getc();

    /* ϡ˥ǽƳ߽Ȥ */
    /* ei(); */

    if ( g_byMoniter_reg_mode == 0 ) {
	switch ( rev_dat ) {
	case K_MON_CODE_BUS:
	    g_wMoniter_reg_a = 0;
	    k_mon_putc( K_MON_A_SIZE );
	    break;
	case K_MON_CODE_ADD:
	    g_byMoniter_reg_mode = K_MON_CODE_ADD;
	    g_wMoniter_reg_a = 0;
	    g_byMoniter_reg_cnt = 0;
	    k_mon_putc( rev_dat );
	    break;
	case K_MON_CODE_MWR:
	    g_byMoniter_reg_mode = K_MON_CODE_MWR;
	    k_mon_putc( rev_dat );
	    break;
	case K_MON_CODE_MRD:
	    tx_dat = peekb( g_wMoniter_reg_a );
	    g_wMoniter_reg_a++;	/* Set next point */
	    k_mon_putc( tx_dat );
	    break;
	case K_MON_CODE_PRD:
	    tx_dat = PRG_RDB( g_wMoniter_reg_a );
	    g_wMoniter_reg_a++;	/* Set next point */
	    k_mon_putc( tx_dat );
	    break;
	case K_MON_CODE_VER:
	    k_mon_putc( K_MON_VERSION );
	    break;
	default:
	    k_mon_putc( K_MON_CODE_NAK );
	    break;
	}
    } else {
	switch ( g_byMoniter_reg_mode ) {
	case K_MON_CODE_MWR:
	    pokeb( g_wMoniter_reg_a, rev_dat );
	    g_wMoniter_reg_a++;	/* Set next point */
	    g_byMoniter_reg_mode = 0; /* mode = 0 */
	    k_mon_putc( rev_dat );
	    break;
	case K_MON_CODE_ADD:
	    g_wMoniter_reg_a <<= 8;
	    g_wMoniter_reg_a += rev_dat;
	    g_byMoniter_reg_cnt++;
	    if ( g_byMoniter_reg_cnt >= K_MON_A_SIZE ) {
		/* mode = 0 */
		g_byMoniter_reg_mode = 0;
	    }
	    k_mon_putc( rev_dat );
	    break;
	default:
	    /* ꡼*/
	    g_byMoniter_reg_mode = 0; /* mode = 0 */
	    k_mon_putc( K_MON_CODE_NAK );
	    break;
	}
    }
}


/*!
  interrupt function (INT0)

  dummyؿȤƼ礨ߤƤ
*/
SIGNAL( SIG_INTERRUPT0 )
{
}


/*!
  NOP򤷤Ƶδؿ
*/
void null_job( void )
{
    _NOP();
}


/*!
  mûԤδؿ
*/
void wait_msec( WORD wTime )
{
    g_wTime1ms_dec_cnt = wTime;
    while ( g_wTime1ms_dec_cnt ) { 
	null_job();
   }
}



/*!
  ưɽ
*/
void opening_task( void )
{
    /* ֥ONLED */
    drv_buz( 1 );
    drv_led( 0x1f );

    /* Ԥ */
    wait_msec( 1000 );

    /* ֥OFFLED */
    drv_buz( 0 );
    drv_led( 0x00 );
}


/*!
  ư1-Ƥ֡Ĥ
*/
void action_task0( void )
{
    /* ֥ONLED */
    drv_buz( 1 );
    drv_led( 0x1f );

    /* KEYΥԤ */
    while ( key_get() != KEY_CODE0_OFF ) {
	null_job();
    }

    /* ֥OFFLED */
    drv_buz( 0 );
    drv_led( 0x00 );
}


/*!
  ư2-ΥǡLED֤Ĥ
*/
void action_task1( void )
{
    int cnt;


    for ( cnt = 0; cnt < 5; cnt ++ ) {
	drv_buz( ( cnt + 1 ) & 1 );
	drv_led( 1 << cnt );

	/* Ԥ */
	wait_msec( 500 );
    }

    /* ֥OFFLED */
    drv_buz( 0 );
    drv_led( 0x00 );
}


/*!
  ư3-ΥǡгѤLEDǤʤĤ
*/
void action_task2( void )
{
    int cnt;


    for ( cnt = 0; cnt < 4; cnt ++ ) {
	/*--- ѥ1 ---*/
	drv_buz( 1 );
	drv_led( 0x0a );

	/* Ԥ */
	wait_msec( 200 );

	drv_buz( 0 );

	/* Ԥ */
	wait_msec( 200 );

	/*--- ѥ2 ---*/
	drv_buz( 1 );
	drv_led( 0x11 );

	/* Ԥ */
	wait_msec( 200 );

	drv_buz( 0 );

	/* Ԥ */
	wait_msec( 200 );
    }

    /* ֥OFFLED */
    drv_buz( 0 );
    drv_led( 0x00 );
}


/*!
  ư4-Υǡ麸ήͤLEDĤ
*/
void action_task3( void )
{
    int cnt;


    for ( cnt = 0; cnt < 4; cnt ++ ) {
	/*--- ѥ1 ---*/
	drv_buz( 1 );
	drv_led( 0x12 );

	/* Ԥ */
	wait_msec( 200 );

	drv_buz( 0 );

	/* Ԥ */
	wait_msec( 200 );

	/*--- ѥ2 ---*/
	drv_buz( 1 );
	drv_led( 0x4 );

	/* Ԥ */
	wait_msec( 200 );

	drv_buz( 0 );

	/* Ԥ */
	wait_msec( 200 );

	/*--- ѥ3 ---*/
	drv_buz( 1 );
	drv_led( 0x09 );

	/* Ԥ */
	wait_msec( 200 );

	drv_buz( 0 );

	/* Ԥ */
	wait_msec( 200 );
    }

    /* ֥OFFLED */
    drv_buz( 0 );
    drv_led( 0x00 );
}


/*!
  Main-Routine
*/
int main( void )
{
    BYTE byKey_code;


    /* Init Port */
    outp( 0x42, DDRD );		/* out:o,in:i,(ioiiiioi) -> (0100_0010) */
    outp( MASK_PORTD, PORTD );	/* inputԥpullupˤ   1011_1101 */
    outp( 0x5f, DDRB );		/* out:o,in:i,(ioiooooo) -> (0101_1111) */
    outp( MASK_PORTB, PORTB );	/* inputԥpullupˤ   1010_0000 */

    /* ޳ߤ */
    tmr0_init();

    /* UARTߤ */
    uart_init();

    /* KEYߤ */
    sw_init();

    /* ѿ */
    g_wTime1ms_dec_cnt = DEF_WTIME1S_DEC_CNT;
    g_wTime1s_dec_cnt = DEF_WTIME1MS_DEC_CNT;
    g_wTimeKey_cnt = SW_KEYSCAN_TIM;
    g_byMoniter_reg_mode = 0;

    /*  */
    sei();

    /* Openning-Mess */
    opening_task();

    /* main-loop */
    while( 1 ) {
	/* KEYԤ */
	g_wTime1s_dec_cnt = PRESET_SLEEP_TIM;
	while( !( byKey_code = key_get() ) ) {
	    if ( g_wTime1s_dec_cnt == 0 ) {
		/* PowerDownذܹԤINT0Υ٥ߤ */
		outp( BV( INT0 ), GIMSK );		// Enable INT0
		outp( BV( SE ) | BV( SM ), MCUCR );	// Select power-down-mode
		_SLEEP();				// sleep

		/* Sleep */
		outp( 0, GIMSK );		// Disable INT0
		outp( 0, MCUCR );		// Disable sleep

		break;
	    }
	}

	/* KEYν */
	switch ( byKey_code ) {
	case ( KEY_CODE0_ON ):
	    action_task0();
	    break;
	case ( KEY_CODE1_OFF ):
	    action_task1();
	    break;
	case ( KEY_CODE2_OFF ):
	    action_task2();
	    break;
	case ( KEY_CODE3_OFF ):
	    action_task3();
	    break;
	default:
	    break;
	}

	/* ٥ȽΥΥ塼 */
	init_swq( 1 );
    }

    return 0;
}
